; 
; About
;
; Author - Bagayev ALEXander (" " - in russian),
; Republic of Uzbekistan, Tashkent city, 2008.
;
; E-mail: ACLOERXE@MAIL.RU
;
; Specially for the MASM32 Project Examples
; 
; This source file - the set of comments slightly "diluted" with a code :-)
;
; 
.386                                    ; create 32 bit code i386 CPU
.model flat,stdcall                     ; 32 bit memory model, calling convention
option casemap:none                     ; case sensitive

comment 
MEMORYSTATUS	STRUCT
	dwLength DWORD ?
	dwMemoryLoad DWORD ?
	dwTotalPhys DWORD ?
	dwAvailPhys DWORD ?
	dwTotalPageFile DWORD ?
	dwAvailPageFile DWORD ?
	dwTotalVirtual DWORD ?
	dwAvailVirtual DWORD ?
MEMORYSTATUS		ENDS



IFNDEF MEMORYSTATUSEX
MEMORYSTATUSEX	STRUCT
	dwLength DWORD ?
	dwMemoryLoad DWORD ?
	ullTotalPhys QWORD ?
	ullAvailPhys QWORD ?
	ullTotalPageFile QWORD ?
	ullAvailPageFile QWORD ?
	ullTotalVirtual QWORD ?
	ullAvailVirtual QWORD ?
	ullAvailExtendedVirtual QWORD ?
MEMORYSTATUSEX		ENDS

ENDIF

; 
; Includes & Libs 1048576

include     \MASM32\include\Windows.inc
include     \MASM32\include\user32.inc
include     \MASM32\include\kernel32.inc
includelib  \MASM32\lib\user32.lib
includelib  \MASM32\lib\kernel32.lib

; 
; Data

.data                                   ; initialized data

caption             db      "MemInfo ",0
fmt                 db      "Total Physical		MiB:",9,"%d  ",13,10        ; preformatted message
                    db      "Free Physical		MiB:",9,"%d  ",13,10        ; string for wsprintfA
	              db      "Total Virtual		MiB:",9,"%d  ",13,10        
                    db      "Free Virtual		MiB:",9,"%d  ",13,10
			  db      "Free extended virtual	MiB:",9,"%d  ",13,10        				
                    db      "Size of Swap File		MB: ",9,"%d  ",13,10        ; WinAPI function
                    db      "Free Swap File		MB: ",9,"%d  ",13,10,13,10
                    db      " ALEX, ACLOERXE@MAIL.RU  ",0

memstat   MEMORYSTATUSEX <>                  				    ; structure for
                                                                            ; GlobalMemoryStatus
                                                                            ; WinAPI function                                                                            
asciiz1               db      4096 dup(0)                                   ; output buffer for
GiGabyte	dd 1000000000
megabyte    dd 1000000
gibibyte    dd 1073741824                                                                       
mebibyte    dd 1048576
result      dd 0                                                                            
; 

	.code                                   ; main code

	start:
	mov memstat.dwLength,sizeof MEMORYSTATUSEX
	invoke GlobalMemoryStatusEx,addr memstat
	;finit

	; NOTE: 
	; instruction
	; shr eax,20
	; is a integer division by 1048576 (2^20), for reduction a bytes value to MegaBytes
	;1073741824 40 000 000h giga
	;-------------------- swap file ---------------------------------				
	fild qword ptr memstat.ullAvailPageFile  ;dwAvailPageFile last parameter of wsprintfA function - size of available
	fidiv megabyte                              ; pagefile (called "swap file" also)
	fistp dword ptr result
	push result		
	fild qword ptr memstat.ullTotalPageFile     ;dwTotalPageFile         ; total size of pagefile
	fidiv megabyte ;GiGabyte
	fistp dword ptr result
	push result	
	;-------------------------virtual --------------------------------------------------
	fild qword ptr memstat.ullAvailExtendedVirtual      
	fidiv mebibyte
	fistp dword ptr result
	push result			
	fild qword ptr memstat.ullAvailVirtual       
	fidiv mebibyte
	fistp dword ptr result
	push result		
	fild qword ptr memstat.ullTotalVirtual       
	fidiv mebibyte
	fistp dword ptr result
	push result				
	
	;----------------------- physical ----------------------------------------------
	fild qword ptr memstat.ullAvailPhys        ;dwAvailPhys  size of free RAM (Random-Access Memory)
	fidiv mebibyte
	fistp dword ptr result
	push result		
	fild qword ptr memstat.ullTotalPhys                   	;dwTotalPhys  first param of wsprintfA function - total size of RAM
	fidiv mebibyte
	fistp dword ptr result
	push result				;dernier en pile,premier  l'affichage

	; pushing the addresses of the strings as params of the wsprintf function
	invoke wsprintf,addr asciiz1,addr fmt   

	; displaying of the program results
	invoke MessageBox,NULL,addr asciiz1,addr caption,MB_ICONINFORMATION or MB_TOPMOST                        

	invoke ExitProcess,0                        ; call to ExitProcess API function

end start
; 


